import { i as intersectionType, c as coreSchema, f as featuresSchema, o as objectType, a as custom } from "./index-4941b7e1.js";
const name = "@workgrid-widgets/client-button";
const version = "1.6.4";
const roots = /* @__PURE__ */ new WeakMap();
const optionsSchema = intersectionType(
  intersectionType(
    coreSchema({
      client: {
        value: `${name}/${version}`,
        final: true
      }
    }),
    featuresSchema()
  ),
  objectType({
    // instanceof breaks when iframes are involved
    target: custom().default(() => {
      const target = document.createElement("div");
      document.body.append(target);
      return target;
    })
  })
);
const index = async (options) => {
  const resolvedOptions = await optionsSchema.parseAsync(options);
  const core = resolvedOptions.core;
  const logger = resolvedOptions.core.createLogger({ prefix: "client-button" });
  const config = await core.getConfig();
  if (!config.isEnabled)
    return;
  const { setup } = await import("./twind-2cd85196.js");
  setup({
    target: resolvedOptions.target,
    theme: { colors: { brand: String(config.theme || "") } }
  });
  const [{ createElement }, { createRoot }, { default: Root }] = await Promise.all([
    import("./index-2fddc4a6.js").then((n) => n.$),
    import("./client-74d00e6c.js").then((n) => n.c),
    import("./root-da04429b.js").then((n) => n.s)
  ]);
  const root = roots.get(resolvedOptions.target) ?? createRoot(resolvedOptions.target);
  if (!roots.has(resolvedOptions.target))
    roots.set(resolvedOptions.target, root);
  root.render(createElement(Root, { ...resolvedOptions, core, logger, config }));
};
export {
  index as default
};
//# sourceMappingURL=index-0df7365a.js.map
