import { i as intersectionType, c as coreSchema, f as featuresSchema, o as objectType } from "./index-4941b7e1.js";
const name = "@workgrid-widgets/client-toolbar";
const version = "0.0.0-legacy.15";
const css = String.raw;
const optionsSchema = intersectionType(
  intersectionType(
    coreSchema({
      client: {
        value: `${name}/${version}`,
        final: true
      }
    }),
    featuresSchema()
  ),
  objectType({})
);
const index = async (options) => {
  var _a;
  const resolvedOptions = await optionsSchema.parseAsync(options);
  const core = resolvedOptions.core;
  const logger = resolvedOptions.core.createLogger({ prefix: "client-toolbar" });
  const config = await core.getConfig();
  if (!config.isEnabled)
    return;
  const source = "https://app.workgrid.com/workgrid-v5.debug.js";
  const companyCode = (_a = /^https:\/\/(.+)\.workgrid\.com\/?$/.exec(await core.getApiHost())) == null ? void 0 : _a[1];
  function init(workgrid2) {
    var _a2;
    if (!workgrid2) {
      logger.error("workgrid is not defined");
      return;
    }
    let generator;
    for (const meta of document.querySelectorAll("meta")) {
      if (((_a2 = meta.name) == null ? void 0 : _a2.toLowerCase()) === "generator") {
        generator = meta.content;
        break;
      }
    }
    if (generator == null ? void 0 : generator.includes("Microsoft SharePoint")) {
      const style = document.createElement("style");
      style.textContent = css`
        .spAppAndPropertyPanelContainer {
          margin-left: 0;
        }
        @media (min-width: 775px) {
          .spAppAndPropertyPanelContainer {
            margin-left: 50px;
          }
        }
        @media (min-width: 992px) {
          .spAppAndPropertyPanelContainer {
            margin-left: 90px;
          }
        }

        .sp-appBar {
          bottom: 45px;
        }
        @media (min-width: 775px) {
          .sp-appBar {
            bottom: 0;
          }
        }

        #workgrid-stylable-wrap {
          z-index: 100;
        }
        @media (min-width: 775px) {
          #workgrid-stylable-wrap {
            margin-top: 48px;
            height: calc(100vh - 48px);
          }
        }
      `;
      document.body.append(style);
    }
    workgrid2.init(() => core.getToken(), config.space, companyCode);
  }
  if (typeof define === "function" && define.amd) {
    logger.trace("Loading with requirejs");
    requirejs(["https://app.workgrid.com/workgrid-v5.debug.js"], init);
  } else {
    logger.trace("Loading with script");
    const script = document.createElement("script");
    script.src = source;
    script.addEventListener("load", () => init(workgrid));
    script.addEventListener("error", logger.error);
    document.body.append(script);
  }
};
export {
  index as default
};
//# sourceMappingURL=index-0fe34edf.js.map
